config/routes.rb
Rails.application.routes.draw do
  scope '/api', format: :json do
    scope '/v1' do
      resources :companies do
        resources :offices
        resources :employees
        resources :projects
      end
    end
  end
  defaults format: :html do
    root 'home#index'
    get 'home/index'
    get '*path', to: 'home#index'
  end
end

app/models/office.rb
class Office < ApplicationRecord
  belongs_to :company
  has_many :employees, dependent: :nullify

  validates :name, presence: true, length: { maximum: 100 }
  validates :address, length: { maximum: 100 }
  validates :tel, length: { maximum: 50 }

  validate :main_office_cannot_be_multiple_selection_when_create, on: :create
  validate :main_office_cannot_be_multiple_selection_when_update, on: :update

  private

  def main_office_cannot_be_multiple_selection_when_create
    if main_office_flag && company.offices.where(main_office_flag: true).count >= 1
      errors.add(:main_office_flag, I18n.t('errors.messages.taken'))
    end
  end

  def main_office_cannot_be_multiple_selection_when_update
    if main_office_flag && company.offices.where(main_office_flag: true).where.not(id: id).count >= 1
      errors.add(:main_office_flag, I18n.t('errors.messages.taken'))
    end
  end
end

app/controllers/offices_controller.rb
class OfficesController < ApplicationController
  before_action :set_office, only: [:show, :edit, :update, :destroy]
  before_action :set_company, only: [:index, :new, :create]

  # GET /offices
  def index
    @offices = @company.offices
  end

  # GET /offices/1
  def show
  end

  # GET /offices/new
  def new
    @office = @company.offices.new
  end

  # GET /offices/1/edit
  def edit
  end

  # POST /offices
  def create
    @office = @company.offices.new(office_params)

    if @office.save
      redirect_to company_office_url(@office.company, @office), notice: t('notice.created')
    else
      render :new
    end
  end

  # PATCH/PUT /offices/1
  def update
    if @office.update(office_params)
      redirect_to company_office_url(@office.company, @office), notice: t('notice.updated')
    else
      render :edit
    end
  end

  # DELETE /offices/1
  def destroy
    @office.destroy
    redirect_to company_offices_url, notice: t('notice.destroyed')
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_office
      @office = Company.find(params[:company_id]).offices.find(params[:id])
    end

    def set_company
      @company = Company.find(params[:company_id])
    end

    # Only allow a list of trusted parameters through.
    def office_params
      params.require(:office).permit(:main_office_flag, :name, :address, :tel)
    end
end

app/views/offices/_form.html.erb
<%= form_with(model: [company, office]) do |form| %>
  <% if office.errors.any? %>
    <div id="error_explanation">
      <h2><%= t('errors.template.header.other', model: t('activerecord.models.office'), count: office.errors.count) %></h2>

      <ul>
        <% office.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label 'company.name' %>
    <%= form.label 'company.name', value: company.name %>
  </div>

  <div class="field">
    <%= form.label :main_office_flag %>
    <%= form.check_box :main_office_flag %>
  </div>

  <div class="field">
    <%= form.label :name %>
    <%= form.text_field :name %>
  </div>

  <div class="field">
    <%= form.label :address %>
    <%= form.text_field :address %>
  </div>

  <div class="field">
    <%= form.label :tel %>
    <%= form.text_field :tel %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/offices/edit.html.erb
<% breadcrumb :edit_office, @office %>

<h1><%= t('.') %></h1>

<%= render 'form', company: @office.company, office: @office %>

<%= link_to t('show'), company_office_path(@office.company, @office) %> |
<%= link_to t('back'), company_offices_path(@office.company) %>

app/views/offices/index.html.erb
<% breadcrumb :offices, @company %>

<p id="notice"><%= notice %></p>

<h1><%= t('.') %></h1>

<table>
  <thead>
    <tr>
      <th><%= "#{t('activerecord.models.company')}#{t('activerecord.attributes.company.name')}" %></th>
      <th><%= t('activerecord.attributes.office.main_office_flag') %></th>
      <th><%= t('activerecord.attributes.office.name') %></th>
      <th><%= t('activerecord.attributes.office.address') %></th>
      <th><%= t('activerecord.attributes.office.tel') %></th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @offices.each do |office| %>
      <tr>
        <td><%= office.company.name %></td>
        <td><%= t("activerecord.attributes.office.main_office_flags.#{office.main_office_flag}") %></td>
        <td><%= office.name %></td>
        <td><%= office.address %></td>
        <td><%= office.tel %></td>
        <td><%= link_to t('show'), company_office_path(office.company, office) %></td>
        <td><%= link_to t('edit'), edit_company_office_path(office.company, office) %></td>
        <td><%= link_to t('destroy'), company_office_path(office.company, office), method: :delete, data: { confirm: t('confirm') } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to t('offices.new'), new_company_office_path(@company) %>

app/views/offices/new.html.erb
<% breadcrumb :new_office, @office.company %>

<h1><%= t('.') %></h1>

<%= render 'form', company: @office.company, office: @office %>

<%= link_to t('back'), company_offices_path(@office.company) %>

app/views/offices/show.html.erb
<% breadcrumb :office, @office %>

<p id="notice"><%= notice %></p>

<p>
  <strong><%= t('activerecord.attributes.company.name') %>:</strong>
  <%= @office.company.name %>
</p>

<p>
  <strong><%= t('activerecord.attributes.office.main_office_flag') %>:</strong>
  <%= t("activerecord.attributes.office.main_office_flags.#{@office.main_office_flag}") %>
</p>

<p>
  <strong><%= t('activerecord.attributes.office.name') %>:</strong>
  <%= @office.name %>
</p>

<p>
  <strong><%= t('activerecord.attributes.office.address') %>:</strong>
  <%= @office.address %>
</p>

<p>
  <strong><%= t('activerecord.attributes.office.tel') %>:</strong>
  <%= @office.tel %>
</p>

<%= link_to t('edit'), edit_company_office_path(@office.company, @office) %> |
<%= link_to t('back'), company_offices_path(@office.company) %>